<?php
// Load WordPress
/*$bootstrap = 'wp-load.php';
while( !is_file( $bootstrap ) ) {
	if( is_dir( '..' ) ) 
		chdir( '..' );
	else
		die( 'Could not find WordPress!' );
}
require_once( $bootstrap );

define( 'WPAS_PREFIX', 'wpas_ticket_' );*/

/* If multisite install, we loop on each blog */
function wpas_uninstall_plugin() {
	if( is_multisite() ) {
		global $wpdb, $current_site;

		/* Let's get all the blogs IDs */
		$site_blog_ids = $wpdb->get_results($wpdb->prepare("SELECT blog_id FROM wp_blogs WHERE 1"));

		/* Loop through all the blogs to delete the data */
		foreach( $site_blog_ids as $blog ) {

			/* Switch to a different blog */
			switch_to_blog( $blog->blog_id );

			/* Delete the data */
			wpas_remove_data();
		}
	} else {
		/* Simply delete the data once */
		wpas_remove_data();
	}

	/* Detete attachments */
	wpas_empty_attachments();
}

function wpas_remove_data() {
	
	/* Delete the plugin data */
	delete_option( WPAS_PREFIX . 'rated' );
	delete_option( WPAS_PREFIX . 'first_setup_date' );
	delete_option( WPAS_PREFIX . 'latest_setup_date' );
	delete_option( WPAS_PREFIX . 'version' );
	delete_option( WPAS_PREFIX . 'plugin_options' );
	delete_option( WPAS_PREFIX . 'email_options' );
	delete_option( WPAS_PREFIX . 'wpas_setup_status' );

	/* Remove the roles */
	remove_role( 'wpas_manager' );
	remove_role( 'wpas_support_manager' );
	remove_role( 'wpas_agent' );

	/* Delete the terms and taxonomies */
	add_action('init', 'wpas_deactivate_custom_taxes');

	/* Delete all posts */
	add_action('init', 'wpas_remove_all_posts');
}

function wpas_remove_all_posts() {
	$history = get_posts( array(
		'numberposts'		=>	999,
		'post_type'			=>	array('ticket_history', 'ticket_reply', 'ticket_status', 'tickets')
		)
	);

	foreach( $history as $post ) {
		wp_delete_post( $post->ID, true );
	}
}

function wpas_deactivate_custom_taxes() {
	wpas_remove_taxonomy('status');
	wpas_remove_taxonomy('type');
	wpas_remove_taxonomy('priority');
	wpas_remove_taxonomy('state');
}

/* Delete taxonomies terms */
function wpas_remove_taxonomy($taxonomy) {
	if (!$taxonomy->_builtin) {
		global $wp_taxonomies;
		$terms = get_terms($taxonomy); 
		foreach ($terms as $term) {
			wp_delete_term( $term->term_id, $taxonomy );
		}
		unset($wp_taxonomies[$taxonomy]);
	}
}

function wpas_empty_attachments() {
	/* Delete all attachments */
	$dirPath = ABSPATH.'wp-content/uploads/wpas_attachments/';

	if ( is_dir($dirPath) ) {
		if (substr($dirPath, strlen($dirPath) - 1, 1) != '/') {
			$dirPath .= '/';
		}

		$files = glob($dirPath . '*', GLOB_MARK);

		foreach ($files as $file) {
			if (is_dir($file)) {
				self::deleteDir($file);
			} else {
				unlink($file);
			}
		}
		
		rmdir($dirPath);
	}
}
?>